package main;
use base DE_EPAGES::Core::API::Test;
use DE_EPAGES::AppStore::API::Url qw ( BuildRedirectUrl );
use DE_EPAGES::Test::Mock::EpagesObject;
use DE_EPAGES::Test::Mock::Mockify;
use Test::More;

use strict;

sub test {
    my $self = shift;
    $self->test_BuildRedirectUrl();
    done_testing();
}

sub test_BuildRedirectUrl {
    my $self        = shift;
    my $SubTestName = ( caller(0) )[3];

    my $Servlet = $self->_createServlet();
    my $CallbackURLBase = 'http://some/url/';
    my $appID = 'myAppID';
    my $dev = 1;
    my $Url = BuildRedirectUrl($Servlet, $CallbackURLBase, $appID, $dev);
    is($Url, 'http://some/url/?return_url=https%3A%2F%2Fhostname%2Fepages%2FMyTestShop.admin%2F%3FObjectID%3D1234%26TestAuthorization%3D1%26ViewAction%3DMBO-ViewDeveloperApp%26appID%3DmyAppID&access_token_url=https%3A%2F%2Fhostname%2Frs%2Fshops%2FMyTestShop%2Ftoken&api_url=https%3A%2F%2Fhostname%2Frs%2Fshops%2FMyTestShop', "$SubTestName - test redirect url" );
}

sub _createServlet {
    my $self = shift;

    my $aParameterList = [];
    my $Mockify = DE_EPAGES::Test::Mock::Mockify->new(
                   'DE_EPAGES::Presentation::Servlet::Permission',
                   $aParameterList
              );

    $Mockify->addMockWithReturnValue('object', $self->_createShop());
    return $Mockify->getMockObject();
}

sub _createShop {
    my $self = shift;

    my $hAtributes = {
        ProtocolAndServerSSL       => 'https://hostname',
        WebServerScriptNamePart    => 'MyTestShop',
        instanceOf                 => 'Shop',
        ID                         => 1234,
        WebServerScriptAdminUrlSSL => 'https://hostname/epages/MyTestShop.admin',
    };
    my $Shop = DE_EPAGES::Test::Mock::EpagesObject->new( 'DE_EPAGES::Shop::API::Object::Shop', $hAtributes );
    $Shop->set('Site' => $Shop);
    return $Shop;
}

__PACKAGE__->runScript();
